// TransporteView.cpp : implementation of the CTransporteView class
//

#include "stdafx.h"
#include "Transporte.h"

#include "TransporteDoc.h"
#include "TransporteView.h"

#include "ResultsDlg.h"
#include "StartDialog.h"
#include "Label.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTransporteView

IMPLEMENT_DYNCREATE(CTransporteView, CScrollView)

BEGIN_MESSAGE_MAP(CTransporteView, CScrollView)
	//{{AFX_MSG_MAP(CTransporteView)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_WM_DESTROY()
	ON_COMMAND(ID_FILE_SOLVE, OnFileSolve)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTransporteView construction/destruction

CTransporteView::CTransporteView()
{
	// TODO: add construction code here

}

CTransporteView::~CTransporteView()
{
}

BOOL CTransporteView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTransporteView drawing

void CTransporteView::OnDraw(CDC* pDC)
{
	CTransporteDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

void CTransporteView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

/////////////////////////////////////////////////////////////////////////////
// CTransporteView diagnostics

#ifdef _DEBUG
void CTransporteView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CTransporteView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CTransporteDoc* CTransporteView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTransporteDoc)));
	return (CTransporteDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTransporteView message handlers

void CTransporteView::OnFileNew() 
{
	// TODO: Add your command handler code here
	int resultado;
	
	CTransporteDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
	if (pDoc->created) {
		//apresenta mensagem de confirmao
		resultado=MessageBox("Ateno, todos os dados do problema anterior sero perdidos!!!","Transporte 1.0",MB_OKCANCEL);
		if (resultado==IDOK) {
			pDoc->LiberaMemoriaProblemaOriginal();
			DesmontaTela(pDoc);
		}
		else
			return;
	}

	//apresenta o dilogo inicial
	CStartDialog dlg=new CStartDialog();
	resultado=dlg.DoModal();
	if (resultado==IDOK) {
		//cria a memoria para o problema
		//e monta a tabela
		pDoc->num_linhas=dlg.m_numFont;
		pDoc->num_colunas=dlg.m_numDest;
		pDoc->CriaMemoriaProblemaOriginal();
		MontaTela(pDoc);

		//monta a tabela
	}

}

void CTransporteView::MontaTela(CTransporteDoc *pDoc)
{

	int linhas=pDoc->num_linhas;
	int colunas=pDoc->num_colunas;
	int index,index2;
	int count=0;
	CString lbl;
	char buffer[20];
	int sizeX=80,sizeY=23;
	RECT rect={sizeX,0,sizeX+sizeX-1,sizeY-1};
	SIZE size;

	//Aloca o espao suficiente para a criao das clulas
	celulas=(CCelulaData **)malloc(sizeof(CCelulaData*)*((linhas*colunas)+linhas+colunas));
	//Aloca espao para os labels da tabela
	labels=(CLabel **)malloc(sizeof(CLabel*)*(linhas+colunas+2));

	//labels demanda
	for (index=0;index<colunas;index++) {
		lbl="D";
		labels[index]=new CLabel;
		labels[index]->Create(lbl+_itoa(index,buffer,10),SS_CENTER | WS_CHILD | WS_VISIBLE,rect,this,0xffff);
		labels[index]->ShowWindow(SW_SHOW);
		rect.left+=sizeX;
		rect.right+=sizeX;
		count++;
	}

	//label "ofertas"
	lbl="Ofertas";
	labels[count]=new CLabel;
	labels[count]->Create(lbl,SS_CENTER | WS_CHILD | WS_VISIBLE,rect,this,0xffff);
	labels[count]->ShowWindow(SW_SHOW);
	count++;

	
	rect.left=0;
	rect.right=rect.left+sizeX-1;
	rect.top=sizeY;
	rect.bottom=rect.top+sizeY-1;

	//labels oferta
	for (index=0;index<linhas;index++) {
		lbl="O";
		labels[count]=new CLabel;
		labels[count]->Create(lbl+_itoa(index,buffer,10),SS_CENTER | WS_CHILD | WS_VISIBLE,rect,this,0xffff);
		labels[count]->ShowWindow(SW_SHOW);
		rect.top+=sizeY;
		rect.bottom+=sizeY;
		count++;
	}
	
	rect.left=0;
	rect.right=rect.left+sizeX-1;
	rect.top=sizeY*(linhas+1);
	rect.bottom=rect.top+sizeY-1;

	//label "demanda"
	lbl="Demandas";
	labels[count]=new CLabel;
	labels[count]->Create(lbl,SS_CENTER | WS_CHILD | WS_VISIBLE,rect,this,0xffff);
	labels[count]->ShowWindow(SW_SHOW);
	count++;

	
	rect.left=sizeX;
	rect.right=rect.left+sizeX-1;
	rect.top=sizeY;
	rect.bottom=rect.top+sizeY-1;

	
	count=0;
	//celulas matriz
	for (index=0;index<linhas;index++) {
		for (index2=0;index2<colunas;index2++) {
			celulas[count]=new CCelulaData(&(pDoc->matriz_problema_original[index][index2]));
			celulas[count]->Create(ES_RIGHT | WS_CHILD | WS_VISIBLE | WS_BORDER,rect,this,0xffff);
			celulas[count]->ShowWindow(SW_SHOW);
			rect.left+=sizeX;
			rect.right+=sizeX;
			count++;
		}
		rect.top+=sizeY;
		rect.bottom+=sizeY;
		rect.left=sizeX;
		rect.right=rect.left+sizeX-1;
	}

	rect.left=sizeX;
	rect.right=rect.left+sizeX-1;
	rect.top=sizeY*(linhas+1);
	rect.bottom=rect.top+sizeY-1;
	
	//vetor demanda
	for (index=0;index<colunas;index++) {
		celulas[count]=new CCelulaData(&(pDoc->vetor_destinos_original[index]));
		celulas[count]->Create(ES_RIGHT | WS_CHILD | WS_VISIBLE | WS_BORDER,rect,this,0xffff);
		celulas[count]->ShowWindow(SW_SHOW);
		rect.left+=sizeX;
		rect.right+=sizeX;
		count++;
	}

	rect.left=sizeX*(colunas+1);
	rect.right=rect.left+sizeX-1;
	rect.top=sizeY;
	rect.bottom=rect.top+sizeY-1;
	
	//vetor oferta
	for (index=0;index<linhas;index++) {
		celulas[count]=new CCelulaData(&(pDoc->vetor_ofertas_original[index]));
		celulas[count]->Create(ES_RIGHT | WS_CHILD | WS_VISIBLE | WS_BORDER,rect,this,0xffff);
		celulas[count]->ShowWindow(SW_SHOW);
		rect.top+=sizeY;
		rect.bottom+=sizeY;
		count++;
	}

	size.cx=sizeX*(colunas+2);
	size.cy=sizeY*(linhas+2);
	SetScrollSizes(MM_TEXT,size,sizeDefault,sizeDefault);
}

void CTransporteView::OnDestroy() 
{
	CScrollView::OnDestroy();
	
	// TODO: Add your message handler code here
	CTransporteDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if (pDoc->created) {
		//libera a memoria e a tabela
		pDoc->LiberaMemoriaProblemaOriginal();
		DesmontaTela(pDoc);
	}

	
}


void CTransporteView::DesmontaTela(CTransporteDoc *pDoc)
{

	int linhas=pDoc->num_linhas;
	int colunas=pDoc->num_colunas;
	int index;

	for (index=0;index<(linhas*colunas)+linhas+colunas;index++)
		delete celulas[index];

	free(celulas);
	
	for (index=0;index<(linhas+colunas+2);index++)
		delete labels[index];

	free(labels);
	
}

void CTransporteView::OnFileSolve() 
{
	// TODO: Add your command handler code here
	int index;
	CTransporteDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	//Atualiza os dados da tabela
	for (index=0;index<(pDoc->num_linhas*pDoc->num_colunas+pDoc->num_linhas+pDoc->num_colunas);index++)
		celulas[index]->Atualiza();

	//Chama  SolveSystem
	pDoc->SolveSystem();

	//Mostra o resultado
	CResultsDlg dlg(this,pDoc);
	dlg.DoModal();

	//LiberaMemoria
    pDoc->LiberaMemoriaDinamica();

}
